

#include <TQObject.h>
#include <RQ_OBJECT.h>

#include "stdio.h"
#include "GVSetPage.h"
#include <TGFrame.h>
#include <TGButtonGroup.h>
#include <TGButton.h>
#include <TGTextEntry.h>
#include <TGLabel.h> 
#include <TGComboBox.h>
#include <TTimer.h>
#include <TApplication.h> 
#include <TGClient.h>

#include <TGLayout.h>
#include <TVirtualPadEditor.h>
#include <TGMsgBox.h>


ClassImp(GVSetPage)
GVSetPage::GVSetPage(const TGWindow *p, const TGWindow *m, UInt_t w, UInt_t h,
		 TString message, Int_t nbTab, TString* PageName,
		Int_t* nbPads) :
	TGTransientFrame(p, m, w, h) {

	fNbTab = nbTab;
	fNewTab = true;
	fNbPadsOld = *nbPads;
	fPageNameOld = *PageName;
	fNbPads = nbPads;
	fPageName = PageName;
	if (strcmp(message.Data(), "Set Page")==0) {
		fNewTab =false;
	}

	fMain = (TGMainFrame*)m;

	SetWindowName(message.Data());
	SetLayoutManager(new TGVerticalLayout(this));

	if (fNewTab)
		fGroup = new TGGroupFrame(this,"Adding Histograms Page");
	else
		fGroup = new TGGroupFrame(this,"Setting Histograms Page");

	fGroup->SetLayoutManager(new TGMatrixLayout(fGroup,3,2,10));
	AddFrame(fGroup);

	fLabNamePage = new TGLabel(fGroup,"Name of current page: ");
	fGroup->AddFrame(fLabNamePage);

	fEntryNamePage = new TGTextEntry(fGroup);
	fGroup->AddFrame(fEntryNamePage);

	fLabNbPads = new TGLabel(fGroup,"Nb of pad in page: ");
	fGroup->AddFrame(fLabNbPads);

	fComboNbPad = new TGComboBox(fGroup);
	const char *nbPad[] = { "1", "4", "9", "16", "25", "36", 0 };
	for (int i =0; i <6; i++) {
		fComboNbPad->AddEntry(nbPad[i], (i+1)*(i+1));
	}

	fComboNbPad->Resize(80, 20);
	if (fNbPadsOld>36)
		fNbPadsOld =36;
	if (fNbPadsOld<1)
		fNbPadsOld =1;
	fComboNbPad -> Select(fNbPadsOld);
	fGroup->AddFrame(fComboNbPad);

	fButtonOk = new TGTextButton(fGroup,"Ok" );
	fButtonOk->Resize(50, 30);
	fButtonOk ->Connect("Clicked()", "GVSetPage", this, "DoOk()     ");
	fGroup-> AddFrame(fButtonOk);

	fButtonCancel = new TGTextButton(fGroup,"Cancel");
	fButtonCancel->Resize(50, 30);
	fButtonCancel->Connect("Clicked()", "GVSetPage", this, "DoCancel()");
	fGroup->AddFrame(fButtonCancel);

	if (fPageNameOld.CompareTo("")!=0)
		fEntryNamePage->SetText(fPageNameOld.Data());

	Layout();
	MapSubwindows();
	CenterOnParent();
	MapWindow();

}

GVSetPage::~GVSetPage() {  
printf ("Delete this\n");
	Cleanup();
	// all object added with AddFrame are already removed with Cleanup
}


void GVSetPage::DoOk() {

	TString tempo;

	tempo= fEntryNamePage->GetDisplayText();
	Int_t nbPads =fComboNbPad->GetSelected();

	Int_t retval;

	if ((fNewTab)&& (nbPads != fNbPadsOld)) {

		EMsgBoxIcon icontype = kMBIconQuestion;
		new TGMsgBox(gClient->GetRoot(), this,
				"Warning","Do you want really change the number of pad in this tab?\n Current histograms in this tab will be deleted !" ,
				icontype, 3, &retval);
		if (retval!=1) {
			DoCancel();
		}

	}
	(*fPageName)= tempo;
	(*fNbPads) = nbPads;

	DoQuit();

}

void GVSetPage::DoCancel() {

	(*fNbPads) = 0;
	(*fPageName) = "";
	DoQuit();

}

void GVSetPage::DoQuit() {

	TTimer::SingleShot(50, "GVSetPage", this, "CloseWindow()");

	// Close the Ged editor if it was activated.
	if (TVirtualPadEditor::GetPadEditor(kFALSE) != 0)
		TVirtualPadEditor::Terminate();
}

void GVSetPage::CloseWindow() {	

	UnmapWindow();
	delete (this);

}


